package body Stack
   --# own State is Pointer, Vector; -- rappresentazione
is
   StackSize : constant Integer := 100; --

   -- subtype Natural is Integer range 0 .. Integer'Last;
   -- subtype Positive is NaturalT range 1 .. Natural'Last;

   subtype PointerT is Natural range Natural'First .. StackSize;

   Pointer : PointerT;

   type IntVectorT is array (Integer range <>) of Integer;
   subtype StackIndexRange is Positive range 1 .. StackSize;
   subtype IntStackT is IntVectorT (StackIndexRange);

   Vector : IntStackT;

   EmptyVector : constant IntStackT := IntStackT'(StackIndexRange => 0);

   -----------
   -- Empty --
   -----------

   function Empty return Boolean
   --# global Pointer;
   is
   begin
      return Pointer = 0; -- and IntVector'First = 0 ; --and IntVectorT'First = 0
   end Empty;

   -----------
   -- Clear --
   -----------

   procedure Clear
   --# global out Pointer, Vector;
   --# derives Pointer, Vector from ;
   is
   begin
      Pointer := 0;
      Vector  := EmptyVector;
   end Clear;

   ---------
   -- Pop --
   ---------

   procedure Pop (X : out Integer)
   --# global in out Pointer; in Vector; -- Vector non  modificato!
   --# derives Pointer from *            -- ma State s.
   --# &             X from Pointer, Vector;
   is
   begin
      X := Vector(Pointer);
      Pointer := Pointer - 1;
   end Pop;

   ----------
   -- Push --
   ----------

   procedure Push (X : in Integer)
   --# global in out Pointer, Vector;
   --# derives Pointer from *
   --# &        Vector from *, Pointer, X;
   is
   begin
      Pointer := Pointer + 1;
      Vector(Pointer) := X;
   end Push;

   function Sum (A : in IntStackT) return Integer
   is
      Result : Integer := 0;
   begin
      cicle:
      for I in StackIndexRange loop --  in IntStackT'Range  non va bene!
         Result := Result + A(I);
      end loop cicle;
      return Result;
   end Sum;

--     function SumAda (A : in IntVectorT) return Integer
--     is
--        Low : Integer := 1;
--        Result : Integer := 0;
--     begin
--        cicle:
--        for I in A'Range loop  -- non passa Examiner
--           Result := Result + A(I);
--        end loop cicle;
--        return Result;
--     end SumAda;

   function SumSPARK (A : in IntVectorT) return Integer
   is
      I : Integer ;
      High : Integer ;
      Result : Integer := 0;
   begin
      I := A'First;
      High := A'Last;
      cicle:
      while I <= High loop
         Result := Result + A(I);
         I := I+1;
      end loop cicle;
      return Result;
   end SumSPARK;

   function SumSPARK2 (A : in IntVectorT) return Integer
   is
      I : Integer ;
      High : Integer ;
      Result : Integer := 0;
   begin
      I := A'First;
      High := A'Last;
      cicle: loop -- while I <= High
         exit cicle when I > High;
         Result := Result + A(I);
         I := I+1;
      end loop cicle;
      return Result;
   end SumSPARK2;

begin
      Pointer := 0;
      Vector  := EmptyVector;
end Stack;
